#!/usr/bin/perl

# Program to visualize the Moire pattern
# due the aliasing
#
# Output: An image in PBM format (Portable BitMap)
#
# Fraga. Mayo 14, 2002

die "Args: T filename\n" if $#ARGV != 1;


$rows = 100;
$cols = 100;

$pi = 3.141592654;

$T = $ARGV[0];
$filename = $ARGV[1];

$w = $pi/$T;

for ( $i=0; $i<$rows; $i++ ) {
	for ( $j=0; $j<$cols; $j++ ) {
		# $fxy = 0.5*sin( 2*$w*$i + $w ) * sin( 2*$w*$j + $w ) + 0.5; 
		$fxy = 0.5*sin( 2*$w*$i + $w ) + 0.5; 
		$gray_tone = int( 255*$fxy + 0.5 );
		$img[ $cols * $i + $j ] = $gray_tone; 
	}
}
$val = save_pgm_img ( \@img, $rows, $cols, $filename );

# Subroutine to save a image in ASCII PBM format
# (see pbm man pages on NETPBM package)
sub save_pgm_img (\@$$$) {  # ( @img, $rows, $cols, $filename );
	local (*myimg) = shift(@_);
	my $myrows = shift(@_);
	my $mycols = shift(@_);
	my $filename = shift(@_);

	my $n = @myimg;
	printf "$n $mycols $myrows $filename\n";

	open ( MYFILE, ">$filename" ) or return 1;

	select MYFILE;
	$| = 1;
	print MYFILE "P5\n";
	print MYFILE "# file: $filename\n";
	print MYFILE "$mycols $myrows\n";
	print MYFILE "255\n";

	my @data;
	for ( my $i=0; $i<$myrows; $i++ ){
		for ( my $j=0; $j<$mycols; $j++ ){
			$data[$j] = $myimg[ $mycols*$i + $j ];
		}

		my $bytes = pack( "C$mycols", @data );
		syswrite ( MYFILE, $bytes, $n );
	}

	close MYFILE;
	return 0;
}
